c***** fftcc.f ***** version: 10 Jun 2008 ******************************
c One-dimensional complex Fourier transform.
c***********************************************************************
      subroutine fftcc(n)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer n
c
c Common Variables:
c
      complex*16 data(ngmx,ngmx),dwk(nxm)
      integer iwk(nxm)
      common/FFTDAT/data,iwk,dwk
c
c Local variables
c
      real*8 rwk(nxm)
      real*8 a0,a1,a2,a3,a4,b0,b1,b2,b3,b4,c1,c2,c3,c30,cm,
     &     half,one,rad,s1,s2,s3,sm,two,z0(2),z1(2),z2(2),
     &     z3(2),z4(2),zero
      complex*16 ak2,za0,za1,za2,za3,za4
      complex*16 dcmplx
      integer i,iam,iap,ibm,ibp,ic,icc,icf,ick,id,idm1,ii,
     &        ija,ikb,ikt,ill,im,ird,isf,isk,isp,iss,ita,itb,
     &        j,ja,jf,jj,jk,k,k0,k1,k2,k3,ka,kb,kd2,kf,kh,
     &        kn,kt,ktp,l,l1,m,mm,mm1,mp
      integer iabs
c                                  SPECifICATIONS FOR LOCAL VARIABLES
      equivalence(za0,z0(1))
      equivalence(za1,z1(1))
      equivalence(za2,z2(1))
      equivalence(za3,z3(1))
      equivalence(a0,z0(1))
      equivalence(b0,z0(2))
      equivalence(a1,z1(1))
      equivalence(b1,z1(2))
      equivalence(a2,z2(1))
      equivalence(b2,z2(2))
      equivalence(a3,z3(1))
      equivalence(b3,z3(2))
      equivalence(za4,z4(1))
      equivalence(z4(1),a4)
      equivalence(z4(2),b4)
      data rad/6.28318530717958647692d0/,c30/.86602540378444d0/
      data zero,half,one,two/0d0,0.5d0,1d0,2d0/
c                                  FIRST EXECUTABLE STATEMENT
      if(n.eq.1)goto1200
      k=n
      m=0
      j=2
      jj=4
      jf=0
c                                  DETERMINE THE SQUARE FACTORS OF N
      iwk(1)=1
      do while(.true.)
        i=k/jj
        if(i*jj.ne.k)then
          j=j+2
          if(j.eq.4)j=3
          jj=j*j
          if(jj.gt.k)then
            kt=m
c                                  DETERMINE THE REMAINING FACTORS OF N
            j=2
            do while(.true.)
              i=k/j
              if(i*j.ne.k)then
                j=j+1
                if(j.ne.3)then
                  j=j+1
                  if(j.gt.k)then
                    k=iwk(m+1)
                    if(iwk(kt+1).gt.iwk(m+1))k=iwk(kt+1)
                    if(kt.gt.0)then
                      ktp=kt+2
                      do i=1,kt
                        j=ktp-i
                        m=m+1
                        iwk(m+1)=iwk(j)
                      enddo
                    endif
                    mp=m+1
                    ic=mp+1
                    id=ic+mp
                    ill=id+mp
                    ird=ill+mp+1
                    icc=ird+mp
                    iss=icc+mp
                    ick=iss+mp
                    isk=ick+k
                    icf=isk+k
                    isf=icf+k
                    iap=isf+k
                    kd2=(k-1)/2+1
                    ibp=iap+kd2
                    iam=ibp+kd2
                    ibm=iam+kd2
                    mm1=m-1
                    i=1
                    goto100
                  endif
                endif
              else
                m=m+1
                iwk(m+1)=j
                k=i
              endif
            enddo
          endif
        else
          m=m+1
          iwk(m+1)=j
          k=i
        endif
      enddo
100   l=mp-i
      j=ic-i
      iwk(ill+l)=0
      if((iwk(j-1)+iwk(j)).eq.4)iwk(ill+l)=1
      if(iwk(ill+l).ne.0)then
        i=i+1
        l=l-1
        iwk(ill+l)=0
      endif
      i=i+1
      if(i.le.mm1)goto100
      iwk(ill+1)=0
      iwk(ill+mp)=0
      iwk(ic)=1
      iwk(id)=n
      do j=1,m
        k=iwk(j+1)
        iwk(ic+j)=iwk(ic+j-1)*k
        iwk(id+j)=iwk(id+j-1)/k
        rwk(ird+j)=rad/iwk(ic+j)
        c1=rad/k
        if(k.gt.2)then
          rwk(icc+j)=dcos(c1)
          rwk(iss+j)=dsin(c1)
        endif
      enddo
      mm=m
      if(iwk(ill+m).eq.1)mm=m-1
      if(mm.gt.1)then
        sm=iwk(ic+mm-2)*rwk(ird+m)
        cm=dcos(sm)
        sm=dsin(sm)
      endif
      kb=0
      kn=n
      jj=0
      i=1
      c1=one
      s1=zero
      l1=1
200   if(iwk(ill+i+1).eq.1)then
        kf=4
        i=i+1
      else
        kf=iwk(i+1)
      endif
      isp=iwk(id+i)
      if(l1.ne.1)then
        s1=jj*rwk(ird+i)
        c1=dcos(s1)
        s1=dsin(s1)
      endif
c                                  FACTORS OF 2,3,AND 4 ARE
c                                  HANDLED SEPARATELY.
300   if(kf.gt.4)then
        jk=kf-1
        kh=jk/2
        k3=iwk(id+i-1)
        k0=kb+isp
        if(l1.ne.1)then
          k=jk-1
          rwk(icf+1)=c1
          rwk(isf+1)=s1
          do j=1,k
            rwk(icf+j+1)=rwk(icf+j)*c1-rwk(isf+j)*s1
            rwk(isf+j+1)=rwk(icf+j)*s1+rwk(isf+j)*c1
          enddo
        endif
        if(kf.ne.jf)then
          c2=rwk(icc+i)
          rwk(ick+1)=c2
          rwk(ick+jk)=c2
          s2=rwk(iss+i)
          rwk(isk+1)=s2
          rwk(isk+jk)=-s2
          do j=1,kh
            k=jk-j
            rwk(ick+k)=rwk(ick+j)*c2-rwk(isk+j)*s2
            rwk(ick+j+1)=rwk(ick+k)
            rwk(isk+j+1)=rwk(ick+j)*s2+rwk(isk+j)*c2
            rwk(isk+k)=-rwk(isk+j+1)
          enddo
        endif
        do while(.true.)
          k0=k0-1
          k1=k0
          k2=k0+k3
          za0=dwk(k0+1)
          a3=a0
          b3=b0
          do j=1,kh
            k1=k1+isp
            k2=k2-isp
            if(l1.eq.1)then
              za1=dwk(k1+1)
              za2=dwk(k2+1)
            else
              k=kf-j
              za4=dwk(k1+1)
              a1=a4*rwk(icf+j)-b4*rwk(isf+j)
              b1=a4*rwk(isf+j)+b4*rwk(icf+j)
              za4=dwk(k2+1)
              a2=a4*rwk(icf+k)-b4*rwk(isf+k)
              b2=a4*rwk(isf+k)+b4*rwk(icf+k)
            endif
            rwk(iap+j)=a1+a2
            rwk(iam+j)=a1-a2
            rwk(ibp+j)=b1+b2
            rwk(ibm+j)=b1-b2
            a3=a1+a2+a3
            b3=b1+b2+b3
          enddo
          dwk(k0+1)=dcmplx(a3,b3)
          k1=k0
          k2=k0+k3
          do j=1,kh
            k1=k1+isp
            k2=k2-isp
            jk=j
            a1=a0
            b1=b0
            a2=zero
            b2=zero
            do k=1,kh
              a1=a1+rwk(iap+k)*rwk(ick+jk)
              a2=a2+rwk(iam+k)*rwk(isk+jk)
              b1=b1+rwk(ibp+k)*rwk(ick+jk)
              b2=b2+rwk(ibm+k)*rwk(isk+jk)
              jk=jk+j
              if(jk.ge.kf)jk=jk-kf
            enddo
            dwk(k1+1)=dcmplx(a1-b2,b1+a2)
            dwk(k2+1)=dcmplx(a1+b2,b1-a2)
          enddo
          if(k0.le.kb)then
            jf=kf
            goto400
          endif
        enddo
      elseif(kf.eq.3)then
        if(l1.ne.1)then
          c2=c1*c1-s1*s1
          s2=two*c1*s1
        endif
        ja=kb+isp-1
        ka=ja+kb
        ikb=kb+1
        ija=ja+1
        do ii=ikb,ija
          k0=ka-ii+1
          k1=k0+isp
          k2=k1+isp
          za0=dwk(k0+1)
          if(l1.eq.1)then
            za1=dwk(k1+1)
            za2=dwk(k2+1)
          else
            za4=dwk(k1+1)
            a1=a4*c1-b4*s1
            b1=a4*s1+b4*c1
            za4=dwk(k2+1)
            a2=a4*c2-b4*s2
            b2=a4*s2+b4*c2
          endif
          dwk(k0+1)=dcmplx(a0+a1+a2,b0+b1+b2)
          a0=-half*(a1+a2)+a0
          a1=(a1-a2)*c30
          b0=-half*(b1+b2)+b0
          b1=(b1-b2)*c30
          dwk(k1+1)=dcmplx(a0-b1,b0+a1)
          dwk(k2+1)=dcmplx(a0+b1,b0-a1)
        enddo
      elseif(kf.eq.4)then
        if(l1.ne.1)then
          c2=c1*c1-s1*s1
          s2=two*c1*s1
          c3=c1*c2-s1*s2
          s3=s1*c2+c1*s2
        endif
        ja=kb+isp-1
        ka=ja+kb
        ikb=kb+1
        ija=ja+1
        do ii=ikb,ija
          k0=ka-ii+1
          k1=k0+isp
          k2=k1+isp
          k3=k2+isp
          za0=dwk(k0+1)
          if(l1.eq.1)then
            za1=dwk(k1+1)
            za2=dwk(k2+1)
            za3=dwk(k3+1)
          else
            za4=dwk(k1+1)
            a1=a4*c1-b4*s1
            b1=a4*s1+b4*c1
            za4=dwk(k2+1)
            a2=a4*c2-b4*s2
            b2=a4*s2+b4*c2
            za4=dwk(k3+1)
            a3=a4*c3-b4*s3
            b3=a4*s3+b4*c3
          endif
          dwk(k0+1)=dcmplx(a0+a2+a1+a3,b0+b2+b1+b3)
          dwk(k1+1)=dcmplx(a0+a2-a1-a3,b0+b2-b1-b3)
          dwk(k2+1)=dcmplx(a0-a2-b1+b3,b0-b2+a1-a3)
          dwk(k3+1)=dcmplx(a0-a2+b1-b3,b0-b2-a1+a3)
        enddo
      else
        k0=kb+isp
        k2=k0+isp
        if(l1.eq.1)then
          do while(.true.)
            k0=k0-1
            if(k0.lt.kb)goto400
            k2=k2-1
            ak2=dwk(k2+1)
            dwk(k2+1)=dwk(k0+1)-ak2
            dwk(k0+1)=dwk(k0+1)+ak2
          enddo
        else
          do while(.true.)
            k0=k0-1
            if(k0.lt.kb)goto400
            k2=k2-1
            za4=dwk(k2+1)
            a0=a4*c1-b4*s1
            b0=a4*s1+b4*c1
            dwk(k2+1)=dwk(k0+1)-za0
            dwk(k0+1)=dwk(k0+1)+za0
          enddo
        endif
      endif
400   if(i.ge.mm)then
        i=mm
        l1=0
        kb=iwk(id+i-1)+kb
        if(kb.ge.kn)then
          i=1
          ja=kt-1
          ka=ja+1
          if(ja.ge.1)then
            do ii=1,ja
              j=ka-ii
              iwk(j+1)=iwk(j+1)-1
              i=iwk(j+1)+i
            enddo
          endif
c                                  THE RESULT IS NOW PERMUTED TO
c                                  NORMAL ORDER.
          if(kt.le.0)goto700
          j=1
          i=0
          kb=0
        else
          do while(.true.)
            jj=iwk(ic+i-2)+jj
            if(jj.ge.iwk(ic+i-1))then
              i=i-1
              jj=jj-iwk(ic+i)
            elseif(i.ne.mm)then
              if(iwk(ill+i).eq.1)i=i+1
              goto200
            else
              c2=c1
              c1=cm*c1-sm*s1
              s1=sm*c2+cm*s1
              goto300
            endif
          enddo
        endif
      else
        i=i+1
        goto200
      endif
500   k2=iwk(id+j)+kb
      k3=k2
      jj=iwk(ic+j-1)
      jk=jj
      k0=kb+jj
      isp=iwk(ic+j)-jj
600   k=k0+jj
      do while(.true.)
        za4=dwk(k0+1)
        dwk(k0+1)=dwk(k2+1)
        dwk(k2+1)=za4
        k0=k0+1
        k2=k2+1
        if(k0.ge.k)then
          k0=k0+isp
          k2=k2+isp
          if(k0.lt.k3)goto600
          if(k0.ge.k3+isp)then
            k3=iwk(id+j)+k3
            if(k3-kb.lt.iwk(id+j-1))then
              k2=k3+jk
              jk=jk+jj
              k0=k3-iwk(id+j)+jk
              goto600
            elseif(j.ge.kt)then
              kb=k3
              if(i.le.0)then
                if(kb.ge.n)goto700
                j=1
                goto500
              else
                j=iwk(ill+i)
                i=i-1
                goto500
              endif
            else
              k=iwk(j+1)+i
              j=j+1
              do while(.true.)
                i=i+1
                iwk(ill+i)=j
                if(i.ge.k)goto500
              enddo
            endif
          else
            k0=k0-iwk(id+j)+jj
            goto600
          endif
        endif
      enddo
700   jk=iwk(ic+kt)
      isp=iwk(id+kt)
      m=m-kt
      kb=isp/jk-2
      if(kt.ge.m-1)goto1200
      ita=ill+kb+1
      itb=ita+jk
      idm1=id-1
      ikt=kt+1
      im=m+1
      do j=ikt,im
        iwk(idm1+j)=iwk(idm1+j)/jk
      enddo
      jj=0
      do j=1,kb
        k=kt
        do while(.true.)
          jj=iwk(id+k+1)+jj
          if(jj.lt.iwk(id+k))then
            iwk(ill+j)=jj
            if(jj.eq.j)iwk(ill+j)=-j
            goto800
          else
            jj=jj-iwk(id+k)
            k=k+1
          endif
        enddo
800   enddo
c                                  DETERMINE THE PERMUTATION CYCLES
c                                  OF LENGTH GREATER THAN OR eqUAL
c                                  TO TWO.
      do j=1,kb
        if(iwk(ill+j).gt.0)then
          k2=j
          do while(.true.)
            k2=iabs(iwk(ill+k2))
            if(k2.eq.j)goto900
            iwk(ill+k2)=-iwk(ill+k2)
          enddo
        endif
900   enddo
c                                  REORDER A FOLLOWING THE
c                                  PERMUTATION CYCLES
      i=0
      j=0
      kb=0
      kn=n
1000  do while(.true.)
        j=j+1
        if(iwk(ill+j).ge.0)then
          k=iwk(ill+j)
          k0=jk*k+kb
          do while(.true.)
            za4=dwk(k0+i+1)
            rwk(ita+i)=a4
            rwk(itb+i)=b4
            i=i+1
            if(i.ge.jk)then
              i=0
              goto1100
            endif
          enddo
        endif
      enddo
1100  k=-iwk(ill+k)
      jj=k0
      k0=jk*k+kb
      do while(.true.)
        dwk(jj+i+1)=dwk(k0+i+1)
        i=i+1
        if(i.ge.jk)then
          i=0
          if(k.ne.j)goto1100
          do while(.true.)
            dwk(k0+i+1)=dcmplx(rwk(ita+i),rwk(itb+i))
            i=i+1
            if(i.ge.jk)then
              i=0
              if(j.lt.k2)goto1000
              j=0
              kb=kb+isp
              if(kb.ge.kn)goto1200
              goto1000
            endif
          enddo
        endif
      enddo
1200  return
      end
